function CheckWindowsTemp {
   param (
	[Parameter(Mandatory=$true)]
	[bool]$ForceDelete
	)

	$topLevelPath = "C:\WINDOWS\TEMP\"
	$directories = Get-ChildItem -Path $topLevelPath -Directory
	Write-Host "==Dir under windows temp:$($directories)"
	foreach ($dir in $directories) {

		$openstackPath = Join-Path -Path $dir.FullName -ChildPath "openstack\\latest\\meta_data.json"

		if (Test-Path -Path $openstackPath) {

			if ($ForceDelete){
				Write-Host "==force remove dir: $($dir.FullName) begin"
				Remove-Item -Path $dir.FullName -Recurse -Force
				Write-Host "==force remove dir: $($dir.FullName) end"
			}else{
				Write-Host "==remove readonly attr: $($dir.FullName) begin"
				$items = Get-ChildItem -Path $dir.FullName -Recurse

				foreach ($item in $items) {
					if ($item.Attributes -match 'ReadOnly') {
						$item.Attributes = $item.Attributes -bxor [System.IO.FileAttributes]::ReadOnly
					}
				}
				Write-Host "==remove readonly attr: $($dir.FullName) end"
			}
		}
	}
}

function RemoveUnattendTempDir(){
	$logPath = "C:\Program Files\Cloudbase Solutions\Cloudbase-Init\log\cloudbase-init-unattend.log"
	$logContent = Get-Content -Path $logPath
	$regex = "(?<=Deleting metadata folder: ')(.*?)(?=' cleanup)"

	foreach ($line in $logContent) {
		if ($line -match $regex) {
			Write-Host "==remove Unattend TempDir: $($Matches[0]) begin"
			Remove-Item -Path $($Matches[0]) -Recurse -Force
			Write-Host "==remove Unattend TempDir: $($Matches[0]) end"
		}
	}
}

function WaitCloudbaseSvcAndDoubleCheck(){
	$serviceName = "cloudbase-init"

	Write-Host "==wait cloudbase svc stop: begin"
	while ((Get-Service -Name $serviceName).Status -ne 'Stopped') {
		Start-Sleep -Milliseconds 10
	}
	Write-Host "==wait cloudbase svc stop: end"

	CheckWindowsTemp -ForceDelete $True
}

CheckWindowsTemp -ForceDelete $False
RemoveUnattendTempDir
WaitCloudbaseSvcAndDoubleCheck
