﻿$cloudbase_init_log = "C:\Program Files\Cloudbase Solutions\Cloudbase-Init\log"
echo "[$(GET-Date -Format 'yyyy/MM/dd HH:mm:ss')] begin-----------------------------" >> $cloudbase_init_log\nic_init.log
ipconfig /all >> $cloudbase_init_log\nic_init.log
route print >> $cloudbase_init_log\nic_init.log
echo "init nics start" >> $cloudbase_init_log\nic_init.log

$IP = "169.254.68.1"
$Mask = "255.255.255.252"
$MasterIndex = -1
$SlaveIndex = -1

function Log ($msg) {
	echo "[$(GET-Date -Format 'yyyy/MM/dd HH:mm:ss')] $msg" >> $cloudbase_init_log\nic_init.log
}

Get-PnpDevice -PresentOnly | Foreach-Object {
    if (($_.InstanceId -like "*PCI\VEN_14E4&DEV_D802&SUBSYS_802114E4*") -or ($_.InstanceId -like "*PCI\VEN_1AF4&DEV_1000&SUBSYS_00011AF4&REV_00\6&1F3212EB&0&00000000")) {
        Log "InstanceId:$($_.InstanceId)"
        $Friendlyname = $_.friendlyname
        $adapter = get-wmiobject win32_networkadapter 
        $adapter | Foreach-Object {
            if ($_.MACAddress -like "*00:FF:FF:FF:FF:FF*") {
                #filter MACAddress
                if ($_.Name -eq $Friendlyname) {
                    #filter FriendlyName
                    Log "SlaveFriendlyname:$($_.Name)"
                    Log "SlaveMACAddress: $($_.MACAddress)"
                    $SlaveIndex = $_.InterfaceIndex
                    Log "SlaveIndex:$SlaveIndex"
                }
            } else {
                if ($_.Name -eq $Friendlyname) {
                    #filter FriendlyName
                    Log "MasterFriendlyname:$($_.Name)"
                    Log "MasterMACAddress: $($_.MACAddress)"
                    $MasterIndex = $_.InterfaceIndex
                    Log "MasterIndex:$MasterIndex"
                }
            }
        }
    }
}

function LogNetInterface ($NetInterface) {
    Log "------------------------------------"

    $DHCPEnabled = $NetInterface.DHCPEnabled
    Log "DHCPEnabled:$DHCPEnabled"

    $IPAddress = ""
    if ($NetInterface.IPAddress.count -gt 0) {
        $IPAddress = $NetInterface.IPAddress[0]
    }
    Log "IPAddress:$IPAddress"

    $DefaultIPGateway = ""
    if ($NetInterface.DefaultIPGateway.count -gt 0) {
        $DefaultIPGateway = $NetInterface.DefaultIPGateway[0]
    }
    Log "DefaultIPGateway:$DefaultIPGateway"

    Log "------------------------------------"
}

$NetInterface = (Get-WmiObject Win32_NetworkAdapterConfiguration | where { $_.InterfaceIndex -eq $SlaveIndex })
if ($NetInterface) {
    Log "Slave SetIp:$IP,Mask:$Mask"
    $NetInterface.EnableStatic([string[]]$IP, $Mask)
}
$NetInterface = (Get-WmiObject Win32_NetworkAdapterConfiguration | where { $_.InterfaceIndex -eq $MasterIndex })
if ($NetInterface) {
    Log "master nic reset and set route"
    Log "before EnableStatic"
    LogNetInterface $NetInterface

    $Gateway = $NetInterface.DefaultIPGateway

    $NetInterface.EnableStatic([string[]]"10.10.10.10", $Mask)
    
    $TempNetInterface = (Get-WmiObject Win32_NetworkAdapterConfiguration | where { $_.InterfaceIndex -eq $MasterIndex })
    Log "after EnableStatic"
    LogNetInterface $TempNetInterface
    
    $RetVal = $NetInterface.EnableDHCP()

    Log "DHCP Enabled Return"
    Log $RetVal.ReturnValue

    do {
        $TempNetInterface = (Get-WmiObject Win32_NetworkAdapterConfiguration | where { $_.InterfaceIndex -eq $MasterIndex })
        if ($TempNetInterface.DefaultIPGateway.count -ne 0) {
            $Gateway = $TempNetInterface.DefaultIPGateway[0]
            break
        }
        sleep(1)
        Log "can not get addr, wait"
    } while (1)

    Log "after EnableDHCP"
    LogNetInterface $TempNetInterface

    route delete 0.0.0.0 -p
    route add 0.0.0.0 mask 0.0.0.0 $Gateway -p
    route delete 169.254.0.0 -p
    route add 169.254.0.0 mask 255.255.128.0 $Gateway -p
    route change 10.0.0.0 mask 255.0.0.0 $Gateway -p
    route change 172.16.0.0 mask 255.240.0.0 $Gateway -p
    route change 192.168.0.0 mask 255.255.0.0 $Gateway -p
}

ipconfig /all >> $cloudbase_init_log\nic_init.log
route print >> $cloudbase_init_log\nic_init.log
echo "init nics success" >> $cloudbase_init_log\nic_init.log
echo "[$(GET-Date -Format 'yyyy/MM/dd HH:mm:ss')] end-----------------------------" >> $cloudbase_init_log\nic_init.log